#include "shared-decls.h"
#include "fragment.h"

// class FragmentVisitor
void
FragmentVisitor::
visitList (FragmentList& fraglist)
{
	for (FragmentList::iterator iter = fraglist.begin() ; iter!=fraglist.end(); iter++) {
		(*iter)->acceptVisitor (*this);
	}
}

//class FragmentFixed : public Fragment
Fragment*
FragmentFixed::
cloneRange (guint32 startByte,
	    guint32 bytesToUse) const
{
	FragmentFixed* newFrag = new FragmentFixed();

	/* O(n^2) */
	for (int i=0;i<bytesToUse;i++) {
		newFrag->addByte (getByte (startByte+i));
	}

	return newFrag;
}

//class FragmentAny : public Fragment
Fragment*
FragmentAny::
cloneRange (guint32 startByte,
	    guint32 bytesToUse) const
{
	return new FragmentAny(bytesToUse);
}


